T3DVectorfield< T > Class Template Reference
Basic data strctures and functions

a 3D vector field More...

`#include <mia/3d/vectorfield.hh>`

Inheritance diagram for T3DVectorfield< T >:
[legend]
Collaboration diagram for T3DVectorfield< T >:
[legend]

## Public Member Functions

T | get_interpol_val_at (const C3DFVector &p) const
C3DFVector | get_voxel_size () const
void | set_voxel_size (const C3DFVector &voxel)
| T3DVectorfield ()
| T3DVectorfield (const C3DBounds &size)
| T3DVectorfield (const C3DBounds &size, const CAttributedData &data)
| T3DVectorfield (const CAttributedData &data, const C3DBounds &size) __attribute__((deprecated))
| T3DVectorfield (const T3DVectorfield< T > &org)
Public Member Functions inherited from T3DDatafield< T >
iterator | begin ()
const_iterator | begin () const
iterator | begin_at (size_t x, size_t y, size_t z)
const_iterator | begin_at (size_t x, size_t y, size_t z) const
range_iterator | begin_range (const C3DBounds &begin, const C3DBounds &end)
const_range_iterator | begin_range (const C3DBounds &begin, const C3DBounds &end) const
range_iterator_with_boundary_flag | begin_range_with_boundary_flags (const C3DBounds &begin, const C3DBounds &end)
const_range_iterator_with_boundary_flag | begin_range_with_boundary_flags (const C3DBounds &begin, const C3DBounds &end) const
void | clear ()
iterator | end ()
const_iterator | end () const
range_iterator | end_range (const C3DBounds &begin, const C3DBounds &end)
const_range_iterator | end_range (const C3DBounds &begin, const C3DBounds &end) const
range_iterator_with_boundary_flag | end_range_with_boundary_flags (const C3DBounds &begin, const C3DBounds &end)
const_range_iterator_with_boundary_flag | end_range_with_boundary_flags (const C3DBounds &begin, const C3DBounds &end) const
value_type | get_avg ()
value_type | get_block_avrg (const C3DBounds &Start, const C3DBounds &BlockSize) const
void | get_data_line_x (int y, int z, std::vector< T > &buffer) const
void | get_data_line_y (int x, int z, std::vector< T > &buffer) const
void | get_data_line_z (int x, int y, std::vector< T > &buffer) const
T2DDatafield< T > | get_data_plane_xy (size_t z) const
T2DDatafield< T > | get_data_plane_xz (size_t y) const
T2DDatafield< T > | get_data_plane_yz (size_t x) const
template<typename Out>
T3DVector< Out > | get_gradient (const T3DVector< float > &p) const
T3DVector< Out > | get_gradient (int hardcode) const
template<typename Out>
T3DVector< Out > | get_gradient (int index) const
template<typename Out>
T3DVector< Out > | get_gradient (size_t x, size_t y, size_t z) const
value_type | get_interpol_val_at (const T3DVector< float > &p) const __attribute__((deprecated))
size_t | get_plane_size_xy () const
Range | get_range (const C3DBounds &start, const C3DBounds &end)
ConstRange | get_range (const C3DBounds &start, const C3DBounds &end) const
const C3DBounds & | get_size () const
bool | holds_unique_data () const __attribute__((deprecated))
void | make_single_ref () __attribute__((deprecated))
template<class TMask>
void | mask (const TMask &m)
reference | operator() (const C3DBounds &l)
const_reference | operator() (const C3DBounds &l) const
reference | operator() (size_t x, size_t y, size_t z)
const_reference | operator() (size_t x, size_t y, size_t z) const
T3DDatafield & | operator= (const T3DDatafield &org)
T3DDatafield & | operator= (T3DDatafield &&org)
| Moave asignment.
reference | operator[] (int i)
const_reference | operator[] (int i) const
void | put_data_line_x (int y, int z, const std::vector< T > &buffer)
void | put_data_line_y (int x, int z, const std::vector< T > &buffer)
void | put_data_line_z (int x, int y, const std::vector< T > &buffer)
void | put_data_plane_xy (size_t z, const T2DDatafield< T > &p)
void | put_data_plane_xz (size_t y, const T2DDatafield< T > &p)
void | put_data_plane_yz (size_t x, const T2DDatafield< T > &p)
void | read_xslice_flat (size_t x, std::vector< atomic_type > &buffer) const
void | read_yslice_flat (size_t y, std::vector< atomic_type > &buffer) const
void | read_zslice_flat (size_t z, std::vector< atomic_type > &buffer) const
size_type | size () const
value_type | strip_avg ()
void | swap (T3DDatafield &other)
| swap the data ofthis 3DDatafield with another one
| T3DDatafield ()
| T3DDatafield (const C3DBounds &_Size)
| T3DDatafield (const C3DBounds &size, const data_array &data)
| T3DDatafield (const C3DBounds &size, const T *data)
| T3DDatafield (const T3DDatafield< T > &org)
| T3DDatafield (T3DDatafield< T > &&org)
void | write_xslice_flat (size_t x, const std::vector< atomic_type > &buffer)
void | write_yslice_flat (size_t y, const std::vector< atomic_type > &buffer)
void | write_zslice_flat (size_t z, const std::vector< atomic_type > &buffer)
virtual | ~T3DDatafield ()
| make sure the destructor is virtual
| CAttributedData ()
| CAttributedData (const CAttributedData &org)
| CAttributedData (PAttributeMap attr)
CAttributedData & | operator= (const CAttributedData &org)
| Assignemt operator.
const PAttribute | get_attribute (const std::string &key) const
CAttributeMap::const_iterator | begin_attributes () const
CAttributeMap::const_iterator | end_attributes () const
void | set_attribute (const std::string &key, PAttribute attr)
void | set_attributes (CAttributeMap::const_iterator begin, CAttributeMap::const_iterator end)
void | set_attribute (const std::string &key, const std::string &value)
template<typename T>
void | set_attribute (const std::string &key, const T &value)
void | set_attribute (const std::string &key, const char *value)
const std::string | get_attribute_as_string (const std::string &key) const
| returns the requested attribute as string, returns an empty string if attribute doesn't exist
template<typename T>
const T | get_attribute_as (const std::string &key) const
template<typename T>
const T | get_attribute_as (const std::string &key, T default_value) const
void | delete_attribute (const std::string &key)
bool | has_attribute (const std::string &key) const
void | print (std::ostream &os) const

## Detailed Description

template<typename T>
class T3DVectorfield< T >

a 3D vector field

This class provides a field of 3D vectors,

Definition at line 38 of file 3d/vectorfield.hh.

## Constructor & Destructor Documentation

## T3DVectorfield() [1/5]

template<typename T>

T3DVectorfield< T >::T3DVectorfield | ( |  | ) |

inline

Definition at line 41 of file 3d/vectorfield.hh.

## T3DVectorfield() [2/5]

template<typename T>

T3DVectorfield< T >::T3DVectorfield | ( | const T3DVectorfield< T > & | org | ) |

inline

Definition at line 42 of file 3d/vectorfield.hh.

## T3DVectorfield() [3/5]

template<typename T>

T3DVectorfield< T >::T3DVectorfield | ( | const C3DBounds & | size | ) |

inline

Definition at line 49 of file 3d/vectorfield.hh.

## T3DVectorfield() [4/5]

template<typename T>

T3DVectorfield< T >::T3DVectorfield | ( | const CAttributedData & | data,
|  | const C3DBounds & | size )

inline

Definition at line 52 of file 3d/vectorfield.hh.

## T3DVectorfield() [5/5]

template<typename T>

T3DVectorfield< T >::T3DVectorfield | ( | const C3DBounds & | size,
|  | const CAttributedData & | data )

inline

Definition at line 58 of file 3d/vectorfield.hh.

## Member Function Documentation

## get_interpol_val_at()

template<typename T>

T T3DVectorfield< T >::get_interpol_val_at | ( | const C3DFVector & | p | ) | const

Interpolate the value of Field at p default uses tri-linear interpolation

## get_voxel_size()

template<typename T>

C3DFVector T3DVectorfield< T >::get_voxel_size | ( |  | ) | const

inline

Definition at line 64 of file 3d/vectorfield.hh.

## set_voxel_size()

template<typename T>

void T3DVectorfield< T >::set_voxel_size | ( | const C3DFVector & | voxel | ) |

inline

Definition at line 85 of file 3d/vectorfield.hh.

The documentation for this class was generated from the following file:

- 3d/vectorfield.hh